

/*
 * 
 * Projects sourced gotten from included Arduino examples and combined into
 *  one project
 * 
 * 
 * 10/5/2017
 * 
 */
 
#include <SPI.h>
#include <MFRC522.h>

#include <LiquidCrystal_I2C.h> //LiquidCrystal.h
#include <Wire.h>

#include "HX711.h"
 
#define SS_PIN 21
#define RST_PIN 22
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.

#define calibration_factor 223.0 //This value is obtained using the SparkFun_HX711_Calibration sketch
#define LOADCELL_DOUT_PIN  14 //21
#define LOADCELL_SCK_PIN  12 //22
HX711 scale;

LiquidCrystal_I2C lcd(0x3F, 16, 2); 

void setup() 
{
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  Serial.println("Approximate your card to the reader...");
  Serial.println();
  lcd.print("Hello!Scan Card");

// Print a message to the LCD.
 //lcd.print("hello, world!");
  // set up the LCD's number of columns and rows:
  Wire.begin (33,32);
  lcd.init();
  lcd.backlight();

  Serial.println("HX711 scale demo");

  scale.begin(LOADCELL_DOUT_PIN, LOADCELL_SCK_PIN);
  scale.set_scale(calibration_factor); //This value is obtained by using the SparkFun_HX711_Calibration sketch
  scale.tare(); //Assuming there is no weight on the scale at start up, reset the scale to 0

  Serial.println("Readings:");
  

}
void loop() 
{
 lcd.setCursor(0,1);
 lcd.print("Hello!Scan Card");
  
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return;
  }
  //Show UID on serial monitor
  lcd.setCursor(0,0);
  Serial.print("UID tag :");
  lcd.print("UID:");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     lcd.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     lcd.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  lcd.print("Message : ");
  content.toUpperCase();
 // if (content.substring(1) == "04 DE CA B2 61 3E 80") // BD 31 15 2B  change here the UID of the card/cards that you want to give access
  if (content.substring(1) == "04 DE CA B2 61 3E 80") //10 76 0B 19
  {
    lcd.setCursor(0,1);
    Serial.println("Pavan");
    Serial.println();
    lcd.print("Suhas");
    lcd.println();
    delay(3000);

    /*Serial.print("Reading: ");
    Serial.print(scale.get_units(), 1); //scale.get_units() returns a float
    Serial.print(" Kg"); //lbs You can change this to kg but you'll need to refactor the calibration_factor
    Serial.println();*/
    
  }
 
 else   {
    lcd.setCursor(0,1);
    Serial.println("Access denied");
    lcd.print("Access denied");
    delay(3000);
  }
} 
